{% import "./macros.j2" as macros %}

<link rel="stylesheet" href="/static/main.css"/>

<style>

 .backlink {
     float: right;
 }

 table.wide tbody tr.nok td {
     background: #f004;
 }

 table.wide tbody tr.stopped td {
     background: #08e4;
 }

 .filtered {
     background: yellow;
 }

 label {
     padding-right: 10px;
 }

 .attribute td {
     border-left: 1px solid black;
 }

</style>


<head>
    <title>ArchWizard 🧙 Archiver {{ archiver}}</title>
</head>

<div class="info">
    <h2>HDB Event Subscriber: {{ archiver }}</h2>

    <a href="{{ url_for('show_manager', manager=manager) }}">Back to manager</a>

    <h3>Status</h3>
    <div class="status">{{status}}</div>

    <table class="status">
        <tr>
            <td>
                <ul>
                    <li># attributes: {{n_attrs}}</li>
                    <li># NOK: {{n_nok}}</li>
                    <li># Stopped: {{n_stopped}}</li>
                    <li># Paused: {{n_paused}}</li>
                </ul>
            </td>

            <td>
                <ul>
                    <li>Server instance: {{info.server_id}}</li>
                    <li>Server host: {{info.server_host}}</li>
                    <li>Last started: {{full_info.started_date}}</li>
                </ul>
            </td>
        </tr>
    </table>

    <h3>Commands</h3>
    <form class="inline" method="get" action="{{ url_for('take_action', manager=manager, action='stop') }}">
        <input type="hidden" name="archiver" value="{{ archiver }}"/>
        <button
            onclick="return confirm('Please confirm that you really want to stop archiving on {{ archiver }}?\n\nThe attributes are not removed from the config, just temporarily stopped.\n\nNote that this page is not updated live so you may have to reload to see the effect.')">
            Stop all
        </button>
    </form>


    <form class="inline" method="get" action="{{ url_for('take_action', manager=manager, action='start') }}">
        <input type="hidden" name="archiver" value="{{ archiver }}"/>
        <button
            onclick="return confirm('Please confirm that you really want to start archiving all stopped attributes on {{ archiver }}?\n\nNote that this page is not updated live so you may have to reload to see the effect.')">
            Start all


        </button>
    </form>

    <form class="inline" method="get" action="{{ url_for('take_action', manager=manager, action='reset') }}">
        <input type="hidden" name="archiver" value="{{ archiver }}"/>
        <button
            onclick="return confirm('Do you really want to reset {{archiver}}? This will zero all statistics counters.\n\nNote that this page is not updated live so you may have to reload to see the effect.')">
            ResetStatistics
        </button>
    </form>
</div>

<form method="get" action="{{ url_for('show_archiver', manager=manager) }}">

    <div class="info">

        <h3>Configured attributes</h3>

        <div class="filters">
            <input type="hidden" name="archiver" value="{{ archiver }}"/>

            <input class="filter{% if filter %} filtered{% endif %}"
                   placeholder="Filter attributes"
                   name="attr_filter" value="{{ filter or '' }}"/>

            {{ macros.filter_only("error", only) }}
            {{ macros.filter_only("events", only) }}
            {{ macros.filter_only("pending", only) }}
            {{ macros.filter_only("started", only) }}
            {{ macros.filter_only("stopped", only) }}

            <button type="submit">
                Apply
            </button>

            <button name="clear" value="true">
                Clear
            </button>
        </div>
    </div>

    <table id="attributes" class="wide sortable">

        <thead>
            <tr>
                <th>
                    {{ macros.sort_header("name", sort, sort_rev) }}
                </th>
                <th title="Status if not normal (NOK, Stopped, ...)">
                    {{ macros.sort_header("status", sort, sort_rev) }}
                </th>
                <th title="Latest error, if any.">
                    {{ macros.sort_header("error", sort, sort_rev) }}
                </th>
                <th title="Total number of stored events since last reset.">
                    {{ macros.sort_header("events", sort, sort_rev) }}
                </th>
                <th title="Number of events waiting to be stored.">
                    {{ macros.sort_header("pending", sort, sort_rev) }}
                </th>
                <th title="Average number of events stored per minute.">
                    {{ macros.sort_header("record_freq", sort, sort_rev) }}
                </th>
                <th title="Operations that can be performed">Actions</th>
            </tr>
        </thead>

        <tbody>
            {% for attr in attributes %}
                <tr id="{{ attr.shortname() }}" class="attribute {% if attr.nok %}nok{% else %}ok{% endif %}{% if attr.started %} started{% else %} stopped{% endif %}">
                    <td>
                        <a href="{{ url_for('show_attribute', manager=manager) }}?attribute={{ attr.name | quote_plus }}">{{ attr.shortname() }}</a>
                    </td>
                    <td>{{ attr.status }}</td>
                    <td>{{ attr.error }}</td>
                    <td>{{ attr.events }}</td>
                    <td>{{ attr.pending or 0 }}</td>
                    <td>{{ attr.record_freq }}</td>
                    <td>
                        {% if attr.started %}
                            <a href="{{ url_for('take_action', manager=manager, action='stop') }}?archiver={{ archiver | quote_plus }}&attribute={{ attr.name | quote_plus }}"
                               title="Temporarily stop archiving of the attribute."
                               onclick="return confirm('Please confirm that you really want to stop:\n\n{{ attr.name }}\n\nThe attribute is not removed from the config, just temporarily stopped.\n\nNote that this page is not updated live so you may have to reload to see the effect.')">
                                Stop
                            </a>
                        {% elif attr.stopped %}
                            <a href="{{ url_for('take_action', manager=manager, action='start') }}?archiver={{ archiver | quote_plus }}&attribute={{ attr.name | quote_plus }}"
                               title="Restart archiving of a stopped attribute."
                               onclick="return confirm('Do you really want to start\n\n {{attr.name}}?\n\nNote that this page is not updated live so you may have to reload to see the effect.')">
                                Start
                            </a>
                        {% endif %}
                    </td>
                </tr>
            {% endfor %}
        </tbody>
    </table>
</form>


<footer>
    <p>
        Rendered at {{ now }}
    </p>
</footer>
